#include "MDR1986VK01.h"

#include <stdio.h>
#include <stdlib.h>
#include "string.h"

#define SMP_REG	(*(volatile unsigned char *)0xE00FE000)

#define Pin_Led_Blue    (9)
#define Pin_Led_Red     (13)
#define Led_Blue        (1 << Pin_Led_Blue)
#define Led_Red         (1 << Pin_Led_Red)

volatile int Test[10];
	
#define locked   1
#define unlocked 0

extern void lock_mutex(void * mutex);
extern void unlock_mutex(void * mutex);

unsigned int output_mutex;
	
int main(void)
{
    int delay, i, Led;

    unlock_mutex(&output_mutex);
	
    if (SMP_REG==0)
	{	
        MDR_CLK->KEY = 0x8555AAA1;
        MDR_CLK->PER0_CLK |=  1<<14; // Enable clock PORTB
	
        MDR_PORTB->KEY      = 0x8555AAA1;
        MDR_PORTB->SANALOG  = Led_Blue | Led_Red;
        MDR_PORTB->SPWR[0]  = (1 << 2*Pin_Led_Blue) | (1 << 2*Pin_Led_Red);
        MDR_PORTB->SOE      = Led_Blue | Led_Red;
    }
    else
    {
        __WFE();  // Wait for an event from CPU0
    }
	
	if (SMP_REG == 0){
        SysTick->LOAD = 8000000/2; // LOAD = CLK/F
        Led = Led_Blue; // Blue Led
        __SEV();        // Send event to CPU1

    }
	else{
		SysTick->LOAD = 8000000/3; // LOAD = CLK/F
        Led = Led_Red; // Red Led
    }
    SysTick->CTRL = 0x5; //CLKSOURCE = HCLK,Enable
	
	while (1) 
	{
		lock_mutex(&output_mutex); // Wait until the mutex is acquired 
		//      call  nonreenterable
		unlock_mutex(&output_mutex); // Leave critical section - release mutex
        
        for(delay = 0; delay < 1000; delay++);

		if (SysTick->CTRL & (1<<16))
		{
            if(++i&1)
                MDR_PORTB->SRXTX = Led;
            else
                MDR_PORTB->CRXTX = Led;
		}
	}
}
